
//
// cle4vdr 2005 - 2018 by Alexander Hans <cle4vdr@arcor.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
// Or, point your browser to http://www.gnu.org/copyleft/gpl.html
//


unit uabout;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls
  {$IFDEF LCLQT}
  , qt4
  {$ENDIF}
  {$IFDEF LCLGTK2}
  , gtk2
  {$ENDIF}   ;

type

  { TfrmAbout }

  TfrmAbout = class(TForm)
    ilAbout: TImageList;
    imCheetah: TImage;
    lbLaz: TLabel;
    lbVersion: TLabel;
    lbUrl: TLabel;
    lbVdr: TLabel;
    lbAuthor: TLabel;
    lbEmail: TLabel;
    lbPower: TLabel;
    lbBuild: TLabel;
    pnAbout: TPanel;
    pnHeader: TPanel;
    GifAnimTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GifAnimTimerTimer(Sender: TObject);
    function GetVersionStr: String;
  private
    index: Integer;
    { private declarations }
  public
    { public declarations }
  end; 

var
  frmAbout: TfrmAbout;

const
  TargetOS    = {$I %FPCTARGETOS%};

implementation

{ TfrmAbout }

uses uinterface;

procedure TfrmAbout.FormCreate(Sender: TObject);
begin
  lbVersion.Caption := 'Version ' + CLEVERSION + ' ' + CLEDATE;
  lbBuild.Caption := GetVersionStr;
  index := 0;
end;

procedure TfrmAbout.FormHide(Sender: TObject);
begin
  GifAnimTimer.Enabled := false;
end;

procedure TfrmAbout.FormShow(Sender: TObject);
begin
  GifAnimTimer.Enabled := true;
end;

procedure TfrmAbout.GifAnimTimerTimer(Sender: TObject);
begin
  inc(index);
  if index > ilAbout.Count-1 then index := 0;
  ilAbout.GetBitmap(index, imCheetah.Picture.Bitmap);
end;

function TfrmAbout.GetVersionStr: String;
begin
  result := '';
  result := TargetOS + ' (';;


  {$IFDEF LCLQT}
    result := result + 'Qt ' + QtVersion + ', libQt4Pas ';

    result := result + IntToStr((QT_VERSION shr 16) and 255) + '.' +
                           IntToStr((QT_VERSION shr  8) and 255) + '.' +
                           IntToStr((QT_VERSION       ) and 255);
  {$ENDIF}

  {$IFDEF LCLGTK2}
    result += 'GTK ' + IntToStr(gtk_major_version) + '.' +
                        IntToStr(gtk_minor_version) + '.' +
                        IntToStr(gtk_micro_version);
  {$ENDIF}
  result += ')';
end;

initialization
  {$I uabout.lrs}

end.

