
//
// cle4vdr 2005 - 2018 by Alexander Hans <cle4vdr@arcor.de>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
// Or, point your browser to http://www.gnu.org/copyleft/gpl.html
//


unit uinterface;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  ComCtrls, ButtonPanel, ExtCtrls, StdCtrls, Grids, Math, LCLtype, MaskEdit,
  Spin;


Type TTwinSortType = (tstNone, tstFreq, tstName, tstProv);

type

  { TfrmMain }

  TfrmMain = class(TForm)
    btSearchTwV: TButton;
    cbCodeRH: TComboBox;
    cbGuard: TComboBox;
    cbSiMiMode: TComboBox;
    cbMod: TComboBox;
    cbHierarchy: TComboBox;
    cbBandwidth: TComboBox;
    cbInversion: TComboBox;
    cbRolloff: TComboBox;
    cbPilotM: TComboBox;
    cbTransmission: TComboBox;
    cbSystem: TComboBox;
    cbCodeRL: TComboBox;
    cbPol: TComboBox;
    cbSourceExp: TComboBox;
    cbSource: TComboBox;
    cbbSort: TComboBox;
    edFrequencyExp: TEdit;
    edChanId: TEdit;
    edIPTVParams: TEdit;
    edVidType: TEdit;
    edVid: TEdit;
    edPcr: TEdit;
    edTeletext: TEdit;
    edTid: TEdit;
    edSid: TEdit;
    edNit: TEdit;
    edRad: TEdit;
    edca: TEdit;
    edShortExp: TEdit;
    edProviderExp: TEdit;
    edNameExp: TEdit;
    edSymbolrateExp: TEdit;
    edName: TEdit;
    edShort: TEdit;
    edProvider: TEdit;
    edKind: TEdit;
    edSource: TEdit;
    edType: TEdit;
    edNumber: TEdit;
    ilSystem: TImageList;
    ilTreeview: TImageList;
    imTeletext: TImage;
    imDolby: TImage;
    imMulti: TImage;
    imEncrypted: TImage;
    ilIcons: TImageList;
    ilSystem2: TImageList;
    Label1: TLabel;
    lbIPTVParams: TLabel;
    lbSiMiMode: TLabel;
    lbtvPol: TLabel;
    lbtvSyblr: TLabel;
    lbtvFreq: TLabel;
    lbtvPos: TLabel;
    lbtvSour: TLabel;
    lbtvProv: TLabel;
    lbtvName: TLabel;
    lbtvPolarisation: TLabel;
    lbtvProvider: TLabel;
    lbtvSource: TLabel;
    lbtvPosition: TLabel;
    lbtvFrequency: TLabel;
    lbtvSymbolrate: TLabel;
    lbEdLanguage: TLabel;
    lbHDTV: TLabel;
    lbEdEncryption: TLabel;
    lbEncryption: TLabel;
    lbSystem: TLabel;
    lbHierarchy: TLabel;
    lbVidType: TLabel;
    lpStreamID: TLabel;
    lbTransm: TLabel;
    lbBandw: TLabel;
    lbCodeH: TLabel;
    lbCodeL: TLabel;
    lbGuard: TLabel;
    lbChanId: TLabel;
    lbInversion: TLabel;
    lbMod: TLabel;
    lbRolloff: TLabel;
    lbVid: TLabel;
    lbCa: TLabel;
    lbTeletext: TLabel;
    lbTid: TLabel;
    lbServId: TLabel;
    lbNit: TLabel;
    lbPcr: TLabel;
    lbRad: TLabel;
    lbNameExp: TLabel;
    lbShortExp: TLabel;
    lbProviderExp: TLabel;
    lbFrequencyExp: TLabel;
    lbSourceExp: TLabel;
    lbPolExp: TLabel;
    lbSymbolrateExp: TLabel;
    lbName: TLabel;
    lbShort: TLabel;
    lbProvider: TLabel;
    lbSource: TLabel;
    lbKind: TLabel;
    lbType: TLabel;
    lbLanguage: TLabel;
    lbNumber: TLabel;
    lpPilotM: TLabel;
    lpT2SysID: TLabel;
    MainMenu1: TMainMenu;
    miRemObsolete: TMenuItem;
    miRemEncrypted: TMenuItem;
    miRemOther: TMenuItem;
    miRemRadio: TMenuItem;
    miRemTV: TMenuItem;
    miRemSource: TMenuItem;
    miRemove: TMenuItem;
    miAbout: TMenuItem;
    miExpVdr: TMenuItem;
    miUpdate: TMenuItem;
    miOpenSorted: TMenuItem;
    miDVB: TMenuItem;
    miExport: TMenuItem;
    miDummy5: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    piUniqueChannel: TMenuItem;
    piDummy4: TMenuItem;
    piDelete: TMenuItem;
    piDummy3: TMenuItem;
    piNewChannel: TMenuItem;
    piSplit: TMenuItem;
    piNewGroup: TMenuItem;
    piDummy2: TMenuItem;
    piMoveTo: TMenuItem;
    piAutoSort: TMenuItem;
    piDummy1: TMenuItem;
    piPaste: TMenuItem;
    piPasteChOnly: TMenuItem;
    piCutChOnly: TMenuItem;
    piCut: TMenuItem;
    piCopy: TMenuItem;
    miHelp: TMenuItem;
    miSearch: TMenuItem;
    miExtras: TMenuItem;
    miPaste: TMenuItem;
    miCut: TMenuItem;
    miCopy: TMenuItem;
    miEdit: TMenuItem;
    miQuit: TMenuItem;
    miSpace2: TMenuItem;
    miClose: TMenuItem;
    miSpace1: TMenuItem;
    miSaveAs: TMenuItem;
    miSave: TMenuItem;
    miFile: TMenuItem;
    miOpen: TMenuItem;
    OpenDialog1: TOpenDialog;
    pnAudio: TPanel;
    pnDolby: TPanel;
    pnSubttl: TPanel;
    pnTwinviewheader: TPanel;
    pnTransponder: TPanel;
    pnPids: TPanel;
    pnParameters: TPanel;
    pcExpert: TPageControl;
    pnExpTabs: TPanel;
    pnTwinview: TPanel;
    pnIcons: TPanel;
    pnHeader: TPanel;
    pnOverview: TPanel;
    pcMain: TPageControl;
    PopupMenu1: TPopupMenu;
    SaveDialog1: TSaveDialog;
    seStreamID: TSpinEdit;
    sgSubttl: TStringGrid;
    seT2SysID: TSpinEdit;
    spLine1: TShape;
    spLine2: TShape;
    sbMain: TStatusBar;
    spLine3: TShape;
    sgAudio: TStringGrid;
    sgDolby: TStringGrid;
    tbClose: TToolButton;
    tbCollapse: TToolButton;
    ScrollTimer: TTimer;
    ToolButton2: TToolButton;
    tsParams: TTabSheet;
    tsTransponder: TTabSheet;
    tsPids: TTabSheet;
    tsLanguage: TTabSheet;
    tbTop: TToolBar;
    tbOpen: TToolButton;
    ToolButton1: TToolButton;
    tbExpand: TToolButton;
    tbSave: TToolButton;
    ToolButton3: TToolButton;
    tbSaveAs: TToolButton;
    tbCopy: TToolButton;
    tbCut: TToolButton;
    tbPaste: TToolButton;
    ToolButton8: TToolButton;
    tbSearch: TToolButton;
    tvTwin: TTreeView;
    tsInfo: TTabSheet;
    tsExpert: TTabSheet;
    tsTwinview: TTabSheet;
    tvMain: TTreeView;
    procedure btSearchTwVClick(Sender: TObject);
    procedure cbbSortChange(Sender: TObject);
    procedure cbSourceEditingDone(Sender: TObject);
    procedure cbSourceExit(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure CleanUp;
    procedure ChangeButtonState(enable: Boolean);
    procedure ChangeMenuState(enable: Boolean);
    procedure miAboutClick(Sender: TObject);
    procedure miCloseClick(Sender: TObject);
    procedure miDVBClick(Sender: TObject);
    procedure miExpVdrClick(Sender: TObject);
    procedure miOpenClick(Sender: TObject);
    procedure miOpenSortedClick(Sender: TObject);
    procedure miQuitClick(Sender: TObject);
    procedure miRemEncryptedClick(Sender: TObject);
    procedure miRemObsoleteClick(Sender: TObject);
    procedure miRemOtherClick(Sender: TObject);
    procedure miRemoveClick(Sender: TObject);
    procedure miRemRadioClick(Sender: TObject);
    procedure miRemTVClick(Sender: TObject);
    procedure miSaveAsClick(Sender: TObject);
    procedure miSaveClick(Sender: TObject);
    procedure miSearchClick(Sender: TObject);
    procedure miUpdateClick(Sender: TObject);
    procedure pcMainPageChanged(Sender: TObject);
    procedure piAutoSortClick(Sender: TObject);
    procedure piCopyClick(Sender: TObject);
    procedure piCutChOnlyClick(Sender: TObject);
    procedure piCutClick(Sender: TObject);
    procedure piDeleteClick(Sender: TObject);
    procedure piMoveToClick(Sender: TObject);
    procedure piNewChannelClick(Sender: TObject);
    procedure piNewGroupClick(Sender: TObject);
    procedure piPasteChOnlyClick(Sender: TObject);
    procedure piPasteClick(Sender: TObject);
    procedure piSplitClick(Sender: TObject);
    procedure piUniqueChannelClick(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure ScrollTimerTimer(Sender: TObject);
    procedure StringGridEditingDone(Sender: TObject);
    procedure tbCloseClick(Sender: TObject);
    procedure tbCollapseClick(Sender: TObject);
    procedure tbExpandClick(Sender: TObject);
    procedure tbPasteClick(Sender: TObject);
    procedure tbSearchClick(Sender: TObject);
    procedure tvMainDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure tvMainDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure tvMainEdited(Sender: TObject; Node: TTreeNode; var S: string);
    procedure tvMainEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure tvMainExit(Sender: TObject);
    procedure tvMainKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure tvMainSelectionChanged(Sender: TObject);
    procedure tvMainStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure tvTwinCompare(Sender: TObject; Node1, Node2: TTreeNode;
      var Compare: Integer);
    procedure tvTwinEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure tvTwinSelectionChanged(Sender: TObject);
    procedure tvTwinStartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure SaveTreeState;
    procedure RestoreTreeState;
    procedure ParametersChange(Sender: TObject);
    procedure EditFieldEnter(Sender: TObject);
    procedure EditFieldExit(Sender: TObject);
    procedure SortTwinView;



  private
    { private declarations }
    CurrentFilePath: String;
    CurrentSavePath: String;
    EditUndoStr: String;
    DragTree: TTreeView;
    scrolldown: Boolean;
    OldExpState: TTreeNodeExpandedState;
    TwinSortType: TTwinSortType;
    procedure CreateNodes;
    procedure FillParameterBoxes;
    procedure RemFunc(Sender: TObject);
  public
    { public declarations }
    ListChanged: Boolean;
    LastTargetNode: TTreeNode;
    procedure RefreshTwinView;
  end; 


var
  frmMain: TfrmMain;
  Node: TTreeNode;
  
const
  CLEVERSION = '0.6.0';
  CLEDATE    = '09.04.2018';
  
  OPENFILTER = 'vdr channel list|*.conf';
  SAVEFILTER = 'vdr channel list|*.conf';
  



implementation

{ TfrmMain }

uses uio, uchannels, uinfo, ushow, uedit, uabout, uutils, uiodvb,
     usearch, uupdate, uunique;


procedure TfrmMain.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  frmMain.Caption := 'cle4vdr ' + CLEVERSION;
  frmMain.Constraints.MinHeight := sbMain.Top + sbMain.Height + 20;
  frmMain.Constraints.MinWidth  := pcMain.Width + 50;
  FillParameterBoxes;
  ChangeButtonState(false);
  ChangeMenuState(false);

  ReadPrefs(CurrentSavePath, CurrentFilePath);
  if CurrentFilePath = '' then CurrentFilePath := ExtractFilePath(Application.ExeName);

  edName.BorderStyle := bsNone;
  edShort.BorderStyle := bsNone;
  edProvider.BorderStyle := bsNone;
  edKind.BorderStyle := bsNone;
  edSource.BorderStyle := bsNone;
  edType.BorderStyle := bsNone;
  edType.BorderStyle := bsNone;
  edNumber.BorderStyle := bsNone;
  edChanId.BorderStyle := bsNone;

  TwinSortType := tstNone;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if ListChanged then
  begin
    if Application.MessageBox('Discard Changes??', 'Confirm', 1) <> 1 then
    CanClose := false;
    Exit;
  end;
  CleanUp;
end;

procedure TfrmMain.CreateNodes;
begin
  Node := NIL;
end;

procedure TfrmMain.FillParameterBoxes;

  function StripVDRParams(AList: TStringList): String;
  var
    i: Integer;
  begin
    result := '';
    for i := 0 to AList.Count-1 do result += AList.ValueFromIndex[i] + ',';
    Delete(result, length(result), 1);
  end;
begin
  frmMain.cbBandWidth.Items.CommaText    := StripVDRParams(BandWidthMap);
  frmMain.cbCodeRH.Items.CommaText       := StripVDRParams(CodeRMap);
  frmMain.cbCodeRL.Items.CommaText       := StripVDRParams(CodeRMap);
  frmMain.cbGuard.Items.CommaText        := StripVDRParams(GuardMap);
  frmMain.cbInversion.Items.CommaText    := StripVDRParams(InversionMap);
  frmMain.cbMod.Items.CommaText          := StripVDRParams(ModulationMap);
  frmMain.cbPilotM.Items.CommaText       := StripVDRParams(PilotModeMap);
  frmMain.cbRollOff.Items.CommaText      := StripVDRParams(RolloffMap);
  frmMain.cbSystem.Items.CommaText       := StripVDRParams(SystemMap);
  frmMain.cbTransmission.Items.CommaText := StripVDRParams(TransmissionMap);
  frmMain.cbSiMiMode.Items.CommaText     := StripVDRParams(SiMiModeMap);
  frmMain.cbHierarchy.Items.CommaText    := StripVDRParams(HierarchyMap);
end;

procedure TfrmMain.CleanUp;
var
  i: Integer;
begin
  if tvMain.Items.Count > 0 then
  begin
    for i := 0 to tvMain.Items.Count - 1 do
      Dispose(cleP(tvMain.Items[i].Data));
    tvMain.Items.Clear;
  end;
  Node := NIL;
  if length(CopyData) > 0 then
    for i := 0 to Length(CopyData) -1 do
      CopyData[i] := NIL;
  tvTwin.Items.Clear;
end;

procedure TfrmMain.ChangeButtonState(enable: Boolean);
begin
  tbSave.Enabled   := enable;
  tbSaveAs.Enabled := enable;
  tbClose.Enabled := enable;
  tbCopy.Enabled := enable;
  tbCut.Enabled := enable;
  tbPaste.Enabled := enable;
  tbSearch.Enabled := enable;
  tbExpand.Enabled := enable;
  tbCollapse.Enabled := enable;
end;


procedure TfrmMain.ChangeMenuState(enable: Boolean);
begin
  miSave.Enabled   := enable;
  miSaveAs.Enabled := enable;
  miClose.Enabled := enable;
  miCopy.Enabled := enable;
  miCut.Enabled := enable;
  miPaste.Enabled := enable;
  miSearch.Enabled := enable;
  miExport.Enabled := enable;
  miUpdate.Enabled := enable;
  miRemove.Enabled := enable;
end;


procedure TfrmMain.pcMainPageChanged(Sender: TObject);
begin
  tvMain.SetFocus;
end;


// ***********  Main Menu Functions **********//

procedure TfrmMain.miOpenClick(Sender: TObject);
begin
  OpenDialog1.Filter := OPENFILTER;
  OpenDialog1.InitialDir := CurrentFilePath;
  if (OpenDialog1.Execute) then
  begin
    CreateNodes;
    if (ReadData(Opendialog1.FileName)) AND (tvMain.Items.Count > 0) then
    begin
      ChangeButtonState(true);
      ChangeMenuState(true);
      RenumberChannels;
      CurrentFilePath := ExtractFilePath(OpenDialog1.FileName);
      SavePrefs(CurrentSavePath, CurrentFilePath);
      sbm(GetChannelsInfo, 1);
      sbm(OpenDialog1.FileName,2);
      tvMain.Selected := tvMain.Items[0];
      RefreshTwinView;
    end
    else tbCloseClick(Self);
  end;
end;

procedure TfrmMain.miOpenSortedClick(Sender: TObject);
begin
  OpenDialog1.Filter := OPENFILTER;
  OpenDialog1.InitialDir := '"'+CurrentFilePath+'"';
  if (OpenDialog1.Execute) then
  begin
    CreateNodes;
    if (ReadData(Opendialog1.FileName, true)) AND (tvMain.Items.Count > 0) then
    begin
      ChangeButtonState(true);
      ChangeMenuState(true);
      RenumberChannels;
      CurrentFilePath := ExtractFilePath(OpenDialog1.FileName);
      SavePrefs(CurrentSavePath, CurrentFilePath);
      sbm(GetChannelsInfo, 1);
      sbm(Opendialog1.FileName, 2);
      tvMain.Selected := tvMain.Items[0];
      RefreshTwinView;
    end
    else tbCloseClick(Self);
  end;
end;



procedure TfrmMain.miSaveClick(Sender: TObject);
begin
  if (ExtractFileExt(OpenDialog1.FileName) = '.conf') then
      WriteData(OpenDialog1.FileName)
end;

procedure TfrmMain.miSearchClick(Sender: TObject);
begin
  tbSearch.Click;
end;

procedure TfrmMain.miUpdateClick(Sender: TObject);
begin
  if OpenDialog1.Execute then frmUpdate.InitUpdate(OpenDialog1.FileName);
end;


procedure TfrmMain.miSaveAsClick(Sender: TObject);
begin
  if CurrentSavePath <> '' then SaveDialog1.InitialDir := CurrentSavePath
  else SaveDialog1.InitialDir := CurrentFilePath;
  SaveDialog1.FileName := ExtractFileName(sbMain.Panels[2].Text);
  if SaveDialog1.FileName = '' then SaveDialog1.FileName := 'channels.conf';
  SaveDialog1.Filter := SAVEFILTER;
  If SaveDialog1.Execute then
  begin
    if (ExtractFileExt(Savedialog1.FileName) = '.conf') OR (Savedialog1.FilterIndex = 1) then
    begin
      WriteData(SaveDialog1.FileName);
      CurrentSavePath := ExtractFilePath(SaveDialog1.FileName);
      SavePrefs(CurrentSavePath, CurrentFilePath);
      sbm(SaveDialog1.FileName,2);
    end
    else exit;
  end;
end;

procedure TfrmMain.miDVBClick(Sender: TObject);
begin
  SaveDialog1.Filter := 'DVB2000|*.dvb';
  SaveDialog1.FileName := ChangeFileExt(ExtractFileName(sbMain.Panels[2].Text), '.dvb');
  If SaveDialog1.Execute then WriteDVB(SaveDialog1.FileName)
end;

procedure TfrmMain.miExpVdrClick(Sender: TObject);
begin
  SaveDialog1.Filter := 'VDR < 1.7|*.conf';
  SaveDialog1.FileName := ChangeFileExt(ExtractFileName(sbMain.Panels[2].Text), '.conf');
  If SaveDialog1.Execute then WriteData(SaveDialog1.FileName, true)
end;


procedure TfrmMain.miQuitClick(Sender: TObject);
begin
  Close;
end;


procedure TfrmMain.RemFunc(Sender: TObject);
begin
  RemoveSources((sender as TMenuitem).Caption);
end;


procedure TfrmMain.miRemoveClick(Sender: TObject);
var
  mi: TMenuItem;
  Sources: TStringList;
  i, j: Integer;
begin
  if miRemSource.Count > 0 then
      for i := miRemSource.Count-1 downto 0 do miRemSource.delete(i);
  Sources := TStringList.Create;
  j := GetAllSources(Sources);
  for i := 0 to j-1 do
  begin
    mi := TMenuItem.Create(MainMenu1);
    mi.Caption := Sources[i];
    mi.OnClick := @RemFunc;
    miRemSource.Add(mi);
  end;
  Sources.Free;
end;


procedure TfrmMain.miRemTVClick(Sender: TObject);
begin
  RemoveAll('TV');
end;

procedure TfrmMain.miRemRadioClick(Sender: TObject);
begin
  RemoveAll('Radio');
end;

procedure TfrmMain.miRemOtherClick(Sender: TObject);
begin
  RemoveAll('Data');
end;

procedure TfrmMain.miRemEncryptedClick(Sender: TObject);
begin
  RemoveAll('Encrypted');
end;

procedure TfrmMain.miRemObsoleteClick(Sender: TObject);
begin
  RemoveAll('Obsolete');
end;


procedure TfrmMain.miAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.miCloseClick(Sender: TObject);
begin
  tbCloseClick(Self);
end;




// ********** Popup Menu ***************//


procedure TfrmMain.PopupMenu1Popup(Sender: TObject);
var
  i: Integer;
begin
  if (tvMain.Items.Count > 0) AND (tvMain.Selected <> NIL) then
  begin
    piCopy.Enabled          := true;
    piCut.Enabled           := true;
    piDelete.Enabled        := true;
    piUniqueChannel.Enabled := NOT isGroupSep(tvMain.Selected);
    piNewChannel.Enabled    := true;
    piNewGroup.Enabled      := true;
    piCutChOnly.Enabled     := isGroupSep(tvMain.Selected) AND (tvMain.Selected.Count > 0);
    piPaste.Enabled         := length(CopyData) > 0;
    piPasteChOnly.Enabled   := (piPaste.Enabled) AND (CopyDataHasGroupSep);
    piSplit.Enabled         := (NOT isGroupSep(tvMain.Selected)) AND (NOT isFirstChild(tvMain.Selected));
    piAutoSort.Enabled      := HasWrongGroupSep(tvMain.Selected) OR (isGroupSep(tvMain.Selected) AND tvMain.Selected.HasChildren);
    piMoveTo.Enabled        := (LastTargetNode <> NIL) AND (NOT isGroupSep(tvMain.Selected)) AND (tvMain.Selected.Parent <> LastTargetNode);
    if piMoveTo.Enabled then piMoveTo.Caption := 'Move to ''' + SetStrLen(LastTargetNode.Text, 13)+''''
    else piMoveTo.Caption := 'Move to ...'
  end
  else for i := 0 to PopupMenu1.Items.Count -1 do
      PopupMenu1.Items[i].Enabled := false;
end;


procedure TfrmMain.piCopyClick(Sender: TObject);
var
  i: Integer;
begin
  if tvMain.Selected = NIL then Exit;
  ClearCopyData;
  setlength(CopyData, 1);
  CopyData[0] := CopyNode(tvMain.Selected);
  if (isGroupSep(tvMain.Selected)) AND (tvMain.Selected.HasChildren) then
  begin
    for i := 0 to tvMain.Selected.Count-1 do
    begin
      setlength(CopyData, length(CopyData)+1);
      CopyData[length(CopyData)-1] := CopyNode(tvMain.Selected[i]);
    end;
  end;
end;

procedure TfrmMain.piCutChOnlyClick(Sender: TObject);
var
  i: Integer;
begin
  if tvMain.Selected = NIL then Exit;
  ClearCopyData;
  if (isGroupSep(tvMain.Selected)) AND (tvMain.Selected.HasChildren) then
  begin
    for i := 0 to tvMain.Selected.Count-1 do
    begin
      setlength(CopyData, length(CopyData)+1);
      CopyData[length(CopyData)-1] := CopyNode(tvMain.Selected[i]);
    end;
  end;
  DeleteNodeChilds(tvMain, tvMain.Selected);
end;

procedure TfrmMain.piCutClick(Sender: TObject);
begin
  piCopyClick(tvMain.Selected);
  DeleteNode(tvMain, tvMain.Selected, true);
end;


procedure TfrmMain.piPasteClick(Sender: TObject);
var
  i: Integer;
  n, m: TTreeNode;
begin
  if tvMain.Selected = NIL then Exit;
  n := tvMain.Selected;
  for i := 0 to length(CopyData)-1 do
  begin
    New(TVP);
    PasteNode(CopyData[i], TVP);
    if CopyData[i]^.Source = '' then
    begin
      if n.Level > 0 then n := n.Parent;
      n := tvMain.Items.InsertObject(n, CopyData[i]^.Name, TVP);
      AssignNodeImage(n);
    end
    else
    begin
      if isGroupSep(n) then
        m := tvMain.Items.AddChildObject(n, CopyData[i]^.Name, TVP)
      else m := tvMain.Items.InsertObject(n, CopyData[i]^.Name, TVP);
      AssignNodeImage(m);
    end;
  end;
  RenumberChannels;
  LastTargetNode := SetLastTarget(n);
end;

procedure TfrmMain.piPasteChOnlyClick(Sender: TObject);
var
  n, m: TTreeNode;
  i: Integer;
begin
  if tvMain.Selected = NIL then Exit;
  tvMain.BeginUpdate;
  n := tvMain.Selected;
  for i := 0 to length(CopyData)-1 do
  begin
    if CopyData[i]^.GroupSep then continue;
    New(TVP);
    PasteNode(CopyData[i], TVP);
    if isGroupSep(n) then
      m := tvMain.Items.AddChildObject(n, CopyData[i]^.Name, TVP)
    else m := tvMain.Items.InsertObject(n, CopyData[i]^.Name, TVP);
    AssignNodeImage(m);
  end;
  RenumberChannels;
  LastTargetNode := SetLastTarget(n);
  tvMain.EndUpdate;
end;


procedure AutoSort(n: TTreeNode);
var
  i: Integer;
  l, m, o: TTreeNode;
  ts: TTreeNodeExpandedState;
begin
  if isGroupSep(n) then
    begin
      frmMain.tvMain.BeginUpdate;
      for i := n.Count-1 downto 0 do AutoSort(n.Items[i]);
      frmMain.tvMain.EndUpdate;
      frmMain.tvMainSelectionChanged(Application);
    end;
  o := n;
  l := GetRightGroupSep(o);
  if l <> NIL then
  begin
    m := FindNextToSelect(o);
    n := m;
    ts := TTreeNodeExpandedState.Create(frmMain.tvMain);
    MoveNode(o, l);
    ts.Apply(frmMain.tvMain);
    ts.Free;
  end;
end;

procedure TfrmMain.piAutoSortClick(Sender: TObject);
begin
  if tvMain.Selected = NIL then Exit;
  AutoSort(tvMain.Selected);
  RenumberChannels;
  FileChanged(true);
end;

procedure TfrmMain.piMoveToClick(Sender: TObject);
var
  m, n: TTreeNode;
  ts: TTreeNodeExpandedState;
begin
  if (tvMain.Selected = NIL) OR (LastTargetNode = NIL) then exit;
  n := tvMain.Selected;
  m := FindNextToSelect(tvMain.Selected);
  tvMain.Selected := m;
  ts := TTreeNodeExpandedState.Create(tvMain);
  MoveNode(n, LastTargetNode);
  ts.Apply(tvMain);
  ts.Free;
end;


procedure TfrmMain.piNewGroupClick(Sender: TObject);
begin
  if tvMain.Selected <> NIL then
  begin
    if tvMain.Selected.Level <> 0 then tvMain.Selected := tvMain.Selected.Parent;
    InsertGroupSep('New Group');
    AssignNodeImage(tvMain.Selected);
  end;
end;

procedure TfrmMain.piSplitClick(Sender: TObject);
var
  i, j: Integer;
  n, m: TTreeNode;
begin
  if isGroupSep(tvMain.Selected) OR (tvMain.Selected.Index = 1) then Exit;
  ClearCopyData;
  if tvMain.Selected.Parent <> NIL then
  begin
    for i := tvMain.Selected.Index to tvMain.Selected.Parent.Count - 1 do
    begin
      setlength(CopyData, length(CopyData)+1);
      CopyData[length(CopyData)-1] := CopyNode(tvMain.Selected.Parent.Items[i]);
    end;
    n := tvMain.Selected.Parent;
    i := tvMain.Selected.Index;
    While n.Count > i do DeleteNode(tvMain, n.Items[i], false);
    n := tvMain.Items.InsertObjectBehind(n, 'Splitted', NewGroupSep('Splitted'));
  end
  else
  begin
    n := tvMain.Selected;
    m := GetNextGroupSep(n);
    if m = NIL then j := tvMain.Items.Count - 1
    else j := m.AbsoluteIndex - 1;
    for i := tvMain.Selected.AbsoluteIndex to j do
    begin
      setlength(CopyData, length(CopyData)+1);
      CopyData[length(CopyData)-1] := CopyNode(tvMain.Items[i]);
    end;
    n := tvMain.Selected.GetPrev;
    for i := j downto tvMain.Selected.AbsoluteIndex do
      DeleteNode(tvMain, tvMain.Items[i], false);
    n := tvMain.Items.InsertObjectBehind(n, 'Splitted', NewGroupSep('Splitted'));
  end;
  AssignNodeImage(n);
  tvMain.Selected := n;
  piPasteChOnlyClick(Self);
  ClearCopyData;
  n.Expanded := true;
  tvMainSelectionChanged(Self);
end;


procedure TfrmMain.piNewChannelClick(Sender: TObject);
begin
  if tvMain.Selected <> NIL then
  begin
    InsertNewChannel(NEWCHANNELSTR, tvMain.Selected);
    AssignNodeImage(tvMain.Selected);
  end;
end;


procedure TfrmMain.piDeleteClick(Sender: TObject);
begin
  DeleteNode(tvMain, tvMain.Selected, true);
end;


procedure TfrmMain.piUniqueChannelClick(Sender: TObject);
begin
  if NOT isUnique(tvMain.Selected) then showmessage('Channel is NOT unique')
  else showmessage('Channel is unique');
end;


// ********* Button Functions **********//


procedure TfrmMain.tbExpandClick(Sender: TObject);
begin
  tvMain.FullExpand;
end;

procedure TfrmMain.tbPasteClick(Sender: TObject);
begin
  piPasteClick(Self);
end;

procedure TfrmMain.tbSearchClick(Sender: TObject);
begin
  frmSearch.SearchTree := frmMain.tvMain;
  frmSearch.ShowModal;
end;

procedure TfrmMain.tbCollapseClick(Sender: TObject);
begin
  tvMain.FullCollapse;
end;

procedure TfrmMain.tbCloseClick(Sender: TObject);
begin
  if (ListChanged) AND (Application.MessageBox('Discard Changes??', 'Confirm', 1) <> 1) then Exit;
  CleanUp;
  sbmclear;
  ClearEditFields;
  FileChanged(false);
  ChangeButtonState(false);
  ChangeMenuState(false);
end;

procedure TfrmMain.btSearchTwVClick(Sender: TObject);
begin
  if tvTwin.Items.Count = 0 then Exit;
  frmSearch.SearchTree := tvTwin;
  frmSearch.ShowModal;
end;

procedure TfrmMain.cbbSortChange(Sender: TObject);
begin
  if tvTwin.Items.Count = 0 then
  begin
    cbbSort.ItemIndex := 0;
    Exit;
  end;
  case cbbSort.ItemIndex of
    0:
       begin
         TwinSortType := tstNone;
         tvTwin.SortType := stNone;
         RefreshTwinView;
       end;
    1:
       begin
         SortTwinView;
         tvTwin.SortType := stNone;
         TwinSortType := tstName;
         tvTwin.SortType := stText;
       end;
    2:
       begin
         SortTwinView;
         tvTwin.SortType := stNone;
         TwinSortType := tstFreq;
         tvTwin.SortType := stText;
       end;
    3:
       begin
         SortTwinView;
         tvTwin.SortType := stNone;
         TwinSortType := tstProv;
         tvTwin.SortType := stText;
       end;
  end;
end;


//********** TreeView ***************//

procedure TfrmMain.tvMainSelectionChanged(Sender: TObject);
begin
  cbSource.SendToBack;
  cbSource.Visible := false;
  ShowOverView(tvMain.Selected);
  ShowExpert(tvMain.Selected);
end;

procedure TfrmMain.tvMainStartDrag(Sender: TObject; var DragObject: TDragObject
  );
begin
  DragTree := tvMain;
end;


procedure TfrmMain.tvTwinStartDrag(Sender: TObject; var DragObject: TDragObject
  );
begin
  DragTree := tvTwin;
end;

procedure TfrmMain.tvMainEndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  DragTree := NIL;
  ScrollTimer.Enabled := false;
end;

procedure TfrmMain.tvMainExit(Sender: TObject);
begin
  //ScrollTimer.Enabled := false;
end;



procedure TfrmMain.tvTwinEndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  DragTree := NIL;
end;

procedure TfrmMain.tvTwinSelectionChanged(Sender: TObject);
begin
  ShowTVOverView(tvTwin.Selected);
end;

procedure TfrmMain.ScrollTimerTimer(Sender: TObject);
var
  n: TTreeNode;
begin
  if scrolldown then
  begin
    n := tvMain.TopItem;
    n := n.getPrevSibling;
    if n <> NIL then tvMain.TopItem := n;
  end
  else
  begin
    n := tvMain.TopItem;
    n := n.getNextSibling;
    if n <> NIL then tvMain.TopItem := n;
  end;
end;

procedure TfrmMain.tvMainDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := true;
  if y < 15 then
  begin
    scrolldown := true;
    ScrollTimer.Enabled := true;
  end
  else if (tvMain.Height - y) < 15 then
  begin
    scrolldown := false;
    ScrollTimer.Enabled:=true;
  end
  else ScrollTimer.Enabled := false;
end;

procedure TfrmMain.tvMainEdited(Sender: TObject; Node: TTreeNode; var S: string
  );
begin
  if Node.Text <> S then
  begin
    cleP(Node.Data)^.Name := S;
    tvMainSelectionChanged(Self);
    FileChanged(true);
  end;
end;

procedure TfrmMain.tvMainDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  AnItem, SourceItem: TTreeNode;
  AttachMode: TNodeAttachMode;
  HT: THitTests;
begin
  if DragTree = NIL then Exit;
  if tvMain.Selected = nil then Exit;
  if DragTree = tvMain then SourceItem := tvMain.Selected
  else if DragTree = tvTwin then SourceItem := TTreeNode(tvTwin.Selected.Data);
  HT := tvMain.GetHitTestInfoAt(X, Y);
  AnItem := tvMain.GetNodeAt(X,Y);
  if AnItem <> NIL then
  begin
    if AnItem = SourceItem then Exit;
    if isGroupSep(AnItem) then       // Item on Group
    begin
      if NOT isGroupSep(SourceItem) then AttachMode := naAddChild   // channel on group
      else AttachMode := naInsert;                                    // group on group
    end
    else
    begin                           // channel on Item
      if isGroupSep(SourceItem) AND (AnItem.Level = 0) then AttachMode := naInsert    // group on channel
      else if isGroupSep(SourceItem) AND (AnItem.Level = 1) then exit                 // group on channnel in group
      else AttachMode := naInsert;                                                      // channel on channel
    end;
    SourceItem.MoveTo(AnItem, AttachMode);
    FileChanged(true);
    RenumberChannels;
  end;
end;

procedure TfrmMain.RefreshTwinView;
var
  i, j: Integer;
  TVState: TTreeNodeExpandedState;
  n: TTreeNode;
begin
  if tvMain.Items.Count = 0 then
  begin
    tvTwin.BeginUpdate;
    tvTwin.Items.Clear;
    tvTwin.EndUpdate;
    exit;
  end;
  if tvTwin.SortType <> stNone then Exit;
  if tvTwin.Selected <> NIL then j := tvTwin.Selected.AbsoluteIndex else j := 0;
  TVState := TTreeNodeExpandedState.Create(tvTwin);
  tvTwin.BeginUpdate;
  tvTwin.Items.Clear;
  for i := 0 to tvMain.Items.Count - 1 do
  begin
    if tvTwin.Items.Count = 0 then n := tvTwin.Items.AddObjectFirst(NIL, tvMain.Items[i].Text, Pointer(tvMain.Items[i]))
    else
    begin
      if tvMain.Items[i].Level = 0 then
        n := tvTwin.Items.AddObject(tvTwin.Items.GetLastNode, tvMain.Items[i].Text, Pointer(tvMain.Items[i]))
      else n := tvTwin.Items.AddChildObject(tvTwin.Items.GetLastNode, tvMain.Items[i].Text, Pointer(tvMain.Items[i]))
    end;
    n.ImageIndex := tvMain.Items[i].ImageIndex;
    n.SelectedIndex := n.ImageIndex;
  end;
  TVState.Apply(tvTwin);
  TVState.Free;
  if j < tvTwin.Items.Count -1 then tvTwin.Selected := tvTwin.Items[j]
  else tvTwin.Selected := tvTwin.Items[0];
  tvTwin.Selected.MakeVisible;
  tvTwin.EndUpdate;
end;



procedure TfrmMain.SortTwinView;
var
  i, j: Integer;
  n: TTreeNode;
begin
  if tvMain.Items.Count = 0 then exit;
  tvTwin.BeginUpdate;
  tvTwin.Items.Clear;
  for i := 0 to tvMain.Items.Count - 1 do
  begin
    if isGroupSep(tvMain.Items[i]) then continue;
    if tvTwin.Items.Count = 0 then n := tvTwin.Items.AddObjectFirst(NIL, tvMain.Items[i].Text, Pointer(tvMain.Items[i]))
    else
      n := tvTwin.Items.AddObject(tvTwin.Items.GetLastNode, tvMain.Items[i].Text, Pointer(tvMain.Items[i]));
    n.ImageIndex := tvMain.Items[i].ImageIndex;
    n.SelectedIndex := n.ImageIndex;
  end;
  tvTwin.EndUpdate;
end;

procedure TfrmMain.tvTwinCompare(Sender: TObject; Node1, Node2: TTreeNode;
  var Compare: Integer);
begin
  Compare := 0;
  case TwinSortType of
    tstFreq:
      begin
        if (Node1.Data = NIL) OR (Node2.Data = NIL) then exit;
        Compare := CompareText(cleP(TTreeNode(Node1.Data).Data)^.Frequency, cleP(TTreeNode(Node2.Data).Data)^.Frequency);
      end;
    tstName:
      begin
        if (Node1.Data = NIL) OR (Node2.Data = NIL) then exit;
        Compare := CompareText(cleP(TTreeNode(Node1.Data).Data)^.Name, cleP(TTreeNode(Node2.Data).Data)^.Name);
      end;
    tstProv:
      begin
        if (Node1.Data = NIL) OR (Node2.Data = NIL) then exit;
        Compare := CompareText(cleP(TTreeNode(Node1.Data).Data)^.Provider, cleP(TTreeNode(Node2.Data).Data)^.Provider);
      end;
  end;
end;

procedure TfrmMain.SaveTreeState;
begin
  if tvMain.Items.Count > 0 then OldExpState := TTreeNodeExpandedState.Create(tvMain);
end;


procedure TfrmMain.RestoreTreeState;
begin
  if OldExpState <> NIL then
  begin
    OldExpState.Apply(tvMain);
    OldExpState.Free;
  end;
end;

// *********** Editing *****************//

procedure TfrmMain.ParametersChange(Sender: TObject);
begin
  ChangeChannelParams(Sender, tvMain.Selected);
  tvMain.SetFocus;
  cbSource.SendToBack;
  cbSource.Visible := false;
end;

procedure TfrmMain.EditFieldEnter(Sender: TObject);
begin
  if tvMain.Selected = NIL then exit;
  EditUndoStr := (Sender as TEdit).Text;
  cbSource.Visible := ((TEdit(Sender) = edSource) AND (tvMain.Selected.Data <> NIL)
                                                  AND (cleP(tvMain.Selected.Data)^.GroupSep = false));
end;

procedure TfrmMain.EditFieldExit(Sender: TObject);
begin
  if (tvMain.Selected = NIL) OR (EditUndoStr = (Sender as TEdit).Text) then Exit;
  if isGroupSep(tvMain.Selected) AND ((Sender <> edName) AND (Sender <> edNameExp))  then
  begin
    frmMain.tvMainSelectionChanged(Self);
    Exit;   // can't change params of groups
  end;
  if NOT ChangeChannelData(tvMain.Selected, (Sender as TEdit).Text, Sender) then
         (Sender as TEdit).Text := EditUndoStr
  else
  begin
    FileChanged(true);
    AssignNodeImage(tvMain.Selected);
    RefreshTwinView;
  end;
  frmMain.tvMainSelectionChanged(Self);
  EditUndoStr := '';
end;


procedure TfrmMain.StringGridEditingDone(Sender: TObject);
var
  i: Integer;
  dummy: String;
begin
  if ((TStringGrid(Sender).Col = 0) AND (NOT TryInteger(TStringGrid(Sender).Cells[TStringGrid(Sender).Col, TStringGrid(Sender).Row], dummy))) then
    begin
      frmMain.tvMainSelectionChanged(Self);
      Exit;
    end;
  if ChangeAudioSubtData(TStringGrid(sender), tvMain.Selected) then FileChanged(true);
end;

procedure TfrmMain.cbSourceEditingDone(Sender: TObject);
begin
  cbSource.SendToBack;
  cbSource.Visible := false;
end;

procedure TfrmMain.cbSourceExit(Sender: TObject);
begin
  cbSource.SendToBack;
  cbSource.Visible := false;
end;





// *********** Keys *****************//
procedure TfrmMain.tvMainKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if tvMain.Selected = NIL then Exit;
  case Key of
    VK_DELETE: DeleteNode(tvMain, tvMain.Selected, true);
  end;
end;



initialization
  {$I uinterface.lrs}

end.

